package stringbuff03;
import java.lang.String;
import java.lang.StringBuffer;
/** Adquirir un texto como en StringBuff01, y luego: 
 * Mostrar texto resultante, 
 * Insertar numero de palabra, entre parentesis,
 * Insertar nmero de lnea, entre corchetes, 
 * Mostrar texto resultante, 
*/
public class StringBuff03{
    private String linea;
    protected StringBuffer texto, copia;
    private int cantPal = 0, cantLin = 0, indice;

    public StringBuff03(){
        texto = new StringBuffer();
    }
    
    public void ciclo(){;   //  Ciclo de adquisicin de datos
        System.out.println("Lineas, fin con linea vacia");
        while((linea = In.readLine()).length() !=0){
            texto.append(linea + "\n");  //  concateno
        }
        copia = new StringBuffer(texto);
    }

    public void insertar(){	// 	El ciclo de insercion
        char carAnt = texto.charAt(0), carAct;
        for(indice=1; indice < texto.length(); indice++){
            carAct = texto.charAt(indice);
            if(finPalabra(carAnt, carAct))
                insertarContPal();
            if(finLinea(carAct)){
                insertarContPal();
                insertarContLin();
            }
            carAnt = carAct;
        }
    }		

    private boolean finPalabra(char ant, char act){
        boolean finPal = false;
        if(ant != ' ' && act == ' ') // es fin palabra
             finPal = true;
        return finPal;
    }
    
    private void insertarContPal(){
        String aux = "(";
        aux+= ++cantPal;
        aux+= ')';
        texto.insert(indice,aux);
        indice+=aux.length();
    }
    
    private boolean finLinea(char act){
        boolean finLin = false;
        if(act == '\n') // es fin linea
             finLin = true;
        return finLin;
    }

    private void insertarContLin(){
        String aux = "[";
        aux+= ++cantLin;
        aux+= ']';
        texto.insert(indice,aux);
        indice+=aux.length();
    }

    public String toString(){
	String cadAux = new String("\nTexto original: \n" + copia 
                        +"\nTexto procesado: \n" + texto);
        return cadAux;
    }
}	  

