package tipo1erparcial;
import java.lang.String;
import java.lang.StringBuffer;
/** Adquirir un texto como en StringBuff01, y luego: 
 * 1 - codificar metodo void vocales(): arma una cadena cadVoc con las vocales 
 * del texto, separadas por un espacio en blanco cada fin de palabra.
 *
 * 2 - codificar metodo void letras(): arma una cadena dinmica cadLet donde
 * se han insertado en orden alfabtico las letras del texto.
 *
 * 3 - Modificar metodo toString(), de manera que:
 *      Muestre el texto adquirido,  
 *      Muestre la cadena de vocales
 *      Muestre la cadena de letras ordenadas alfa.
*/
public class StringBuff04{
    private String linea;   //  linea leida
    protected String texto; //  texto generado
    protected String cadVoc;
    protected StringBuffer cadLet;
    
    public StringBuff04(){
        cadVoc = new String();
        cadLet = new StringBuffer();
        texto  = new String();
    }

    public void ciclo(){;   //  Ciclo de adquisicin de datos
        System.out.println("Lineas, fin con linea vacia");
        while((linea = In.readLine()).length() !=0){
            texto += (linea + "\n");  //  concateno
        }
    }

    public void vocales(){	//  ciclo generando vocales
        char carAnt = texto.charAt(0), carAct;
        for(int indice=0; indice < texto.length(); indice++){
            carAct = texto.charAt(indice);
            Caracter car = new Caracter(carAct);
            if(car.esVocal()) cadVoc += carAct; 
            if(finPalabra(carAnt, carAct))
                cadVoc += ' ';
            carAnt = carAct;
        }
    }		

    private boolean finPalabra(char ant, char act){
        boolean finPal = false;
        if(ant != ' ' && act == ' ') // es fin palabra
             finPal = true;
        return finPal;
    }
    
    public void letras(){	//  ciclo recorriendo texto
        char carAct;
        for(int indice=0; indice < texto.length(); indice++){
            carAct = texto.charAt(indice);
            Caracter car = new Caracter(carAct);
            if(car.esLetra()) insertAlfa(carAct); 
        }
    }		

    public void insertAlfa(char actual){
        boolean insOk = false;
        for(int indice=0; indice < cadLet.length(); indice++)
            if(indice>0)
                if(actual < cadLet.charAt(indice)){
                    cadLet.insert(indice,actual);
                    insOk = true;
                    break;
                }
        if(!insOk)cadLet.append(actual);
    }
    
    public String toString(){
	String cadAux = new String("\nTexto original: \n" + texto 
                        +"\nVocales: \n" + cadVoc 
                        +"\nLetras : \n" + cadLet);
        return cadAux;
    }
}	  

