package linea04;

    /*  Introducir lineas de texto concatenandolas formando un texto
     *  Cada nueva linea va debajo de la anterior
     *  Fin de entrada por linea vacia.
     *
     *  Se pide:
     *  Repetir n(parametro pasado desde main) veces el siguiente proceso:
     *  1) - Detectar la mas larga palabra del texto. 
     *  2) - Recortarla, reemplazando su ultimo caracter por un asterico.
     *  El metodo toString debe devolver una cadena conteniendo texto original  
     *  y texto con reemplazos.
     *
     *  Para detectar fin de palabra usaremos el concepto de separador:
        Un separador es todo aquello que no sea letra. O sea signos de puntuacin, 
        espacio en blanco, inclusive el '\n'.
        Usaremos un mtodo privado que llamaremos esSeparador que nos devolver 
        verdadero si el caracter es signo o espacio y falso en caso contrario. 
     */

public class Linea04{ 
    // Atributos private String linea;
    private String       textoOrig;
    private StringBuffer textoReem;
    private String separador = " *!@I$%&/()=?A[]{}+,;.:\n";
    private int veces;
    public Linea04(int vez) {  //  Constructor
        textoOrig = "";
        veces = vez;
    }

    public void cicloLectura(){;
        String linea;
        System.out.println("Lineas, fin con linea vacia");
        while((linea = In.readLine()).length() !=0){
            textoOrig += linea + "\n";  //  concateno
        }
        textoReem = new StringBuffer(textoOrig);
    }

    public void tarea(){ 
        char carAnt = textoReem.charAt(0);
        char carAct = textoReem.charAt(0);
        int longAct;    //  longitud de la palabra actual
        int longAnt;        //  longitud de la palabra anterior
        int posUltCar;      //  Ultimo caracter de la palabra mas larga
        for(int vez=0;vez<veces;vez++){ // Cantidad de barridas
            posUltCar = -1;
            longAnt = 0;
            longAct = 0;
            for(int ind = 0; ind < textoReem.length(); ind++){  //  Barrida

                //  El cuerpo del ciclo interno lo codifica el alumno
                
            }   //  for interno
            // Es el momento propicio para el recorte
            if(posUltCar>=0)    //  hay palabra a asteriscar
                textoReem.replace(posUltCar,posUltCar+1,"*");        
        }       // for externo
    } // void tarea()
    
    private boolean esSeparador(char car){ 
        boolean signo = false; int ind; char sepa; 
        for(ind = 0; ind < separador.length(); ind++) { 
            sepa = (char)separador.charAt(ind); 
            if (car == sepa) {      // encontro, es signo o espacio
                signo = true; break;
            }
        }            
        return signo;
    }

     public String toString(){ 
        String auxStr ="";
        auxStr = "El texto leido es: \n";
        auxStr+= textoOrig;
        auxStr+= "El texto c/reempl es: \n";
        auxStr+= textoReem+"\n";
        return auxStr;
    }
}

