package pallarga01;
public class PalLar01{
    /* Variante de PalLarga. Utilizamos el concepto de separador:
        Un separador es todo aquello que no sea letra.
        O sea signos de puntuacin, inclusive' '.
        Usaremos un mtodo privado que llamaremos esSeparador que nos 
        devolver verdadero si el caracter es signo o espacio
        y falso en caso contrario
        @author Tymos @version 04-04-2007
    */

    // Atributos private String linea;
    private String texto, linea;
    private int cuantPal, cuantLin;
    private int linPalLarga;
    private int linLarga; // 	Longitud de la lnea mas larga 
    private int palLarga; // 	Longitud de la palabra mas larga
    private int contLin;  //	Contador de lineas del texto
    private int contLet;  //	Contador de letras de la palabra	
    private String separa = " !@$%&/()=?[]{}+,;.:";

    public PalLar01(int cuantas) {
        cuantLin = cuantas;  //  Constructor
        linea = "";
        texto = "\n";
        linLarga = palLarga = cuantPal = linPalLarga = contLin = contLet = 0;
    }

    public void ciclo() { 
        int auxLarg;
        for(contLin =1; contLin <= cuantLin; contLin++){
            System.out.println("Linea "+contLin+", por favor");
            linea = In.readLine();
            auxLarg = linea.length();
            if (auxLarg > linLarga) linLarga = auxLarg; // Lnea
            detPalLarga() ;
            texto += linea + " \n"; // concateno
        }
    }

    public void detPalLarga(){
        char carAnt, carAct;
        carAnt = carAct = ' ';
        int ind;
        for(ind = 1; ind < linea.length(); ind++) {
            carAnt = linea.charAt(ind-1); carAct = linea.charAt(ind);
            if (esSeparador(carAct) && !esSeparador(carAnt)){ // Fin de palabra
                finPalabra(); //  Trato palabras anteriores a la ultima
            }
            if (!esSeparador(carAct)) contLet++; 
        } // for
        if (!esSeparador(carAct)) finPalabra(); // Trato ultima palabra
    } // void palLarga()

    private boolean esSeparador(char car) {
        boolean signo = false; int ind; char sepa; 
        for(ind = 0; ind < separa.length(); ind++) {
            sepa = (char)separa.charAt(ind); 
            if (car == sepa) {      // encontro, es signo o espacio
                signo = true; break;
            }
        }            
        return signo;
    }

    private void finPalabra(){
        cuantPal++;
        if (contLet > palLarga) { // una palabra mas larga
            palLarga = contLet;   // de tantas letras
            linPalLarga = contLin;   // en la linea
        }
        contLet = 0;
    }

    public String toString(){
        texto += "El texto contiene "+cuantPal+" palabras, \n";
        texto += "la mas larga lnea tiene " + linLarga + " caracteres \n";
        texto += "la mas larga palabra tiene " + palLarga + " caracteres \n";
        texto +="y se encuentra en la linea " + linPalLarga+"\n";
        return texto;
    }

    public static void main(String args[]){
        int ctas = 0;
        System.out.println("Cuantas lneas procesamos?");
        ctas = In.readInt(); 
        PalLar01 pLar = new PalLar01(ctas);
        pLar.ciclo(); 
        System.out.print(pLar);
    }
}

