package pallarga02;
// @author tymos
public class PalLarga02 {
      /* Enunciado: Variante de PalLarga01.
       * Leer lineaLeid, guardarla en lineaTrab;
       * Ciclo trabajando con lineaTrab, mientras haya palabras:
       *    . Se detecta la mas palabra mas larga
       *    . se la concatena en lineaRes
       *    . se la deletea de lineaTrab
       * Al finalizar:
       *     . exhibir lineaLeid, lineaTrab  y lineaRes
       *     . informar cantidad de palabras borradas
       * @author Tymos @revision 02-05-2009
    */
    //  Atributos 
    private String lineaLeid, lineaRes;
    private StringBuffer lineaTrab;
    private String separa = " !@$%&/()=?¿[]{}+,;.:";
    private char carAct, carAnt;
    private int posIni, posFin;   // Posiciones inicial y final de cada palabra
    private int larIni, larFin;   // Idem de la palabra mas larga a borrar
    private String palLarga;  // Palabra mas larga a appendar y borrar
    private String palabra;   // Ultima palabra detectada
    private int borradas;   //  Contador borradas
    private int masLarga;   //  La mas larga palabra de lineaTrab
    private int contLetras; //  Longitud de la palabra que acabo de leer
    boolean primeraLetra;   //  Bandera por primera letra

    
    public PalLarga02() {     //  Constructor
        lineaLeid = new String();    //  Hileras vacias
        lineaRes  = new String();
        palLarga  = new String();
        palabra   = new String();
        borradas = 0;
        masLarga = 0;
        contLetras = 0;
        primeraLetra = true;
    }

    public void ciclo() {
        System.out.println("Una linea, por favor");
        lineaLeid = In.readLine();        
        lineaTrab = new StringBuffer(lineaLeid);    //  Copiamos
        while(quedanPalabras()){
            detectarMasLarga();
            tarea();
        }
    }
    
    private boolean quedanPalabras(){
        boolean quedan = false;
        for(int ind = 0; ind < lineaTrab.length(); ind++)
            if (!esSeparador(lineaTrab.charAt(ind))){
                quedan = true; break;
            };
        return quedan;
    }
        
    public void detectarMasLarga(){
        carAnt = ' '; int ind;
        posIni = masLarga = 0; //  Por las dudas
        for(ind = 0; ind < lineaTrab.length(); ind++) {
            carAct = lineaTrab.charAt(ind);
            if (!esSeparador(carAct)){  //  Entonces es caracter de palabra
                if(primeraLetra){
                    primeraLetra = false;   //  Invertimos bandera
                    posIni = ind;           //  Registramos posicion
               }
                palabra+=carAct;   //  Armamos la palabra
                contLetras++;
            }
            if (esSeparador(carAct) && !esSeparador(carAnt)){ // Fin de palabra
                finPalabra(ind); //  Trato palabras anteriores a la ultima
            }
            carAnt = carAct;
        } // for
        if (!esSeparador(carAct)) finPalabra(ind); // Trato ultima palabra
    } // void palLarga()

    private void tarea(){
            lineaRes += (palLarga+" ");  //  Concatenamos en lineaRes
            System.out.println("Listo para borrar: " + palLarga);
            System.out.println("Posiciones larIni: "+larIni+" larFin: "+larFin);
            lineaTrab.delete(larIni, larFin);   //  Borramos de lineaTrab
            borradas++;
            palLarga = "";  //  Re inicializamos
            masLarga = 0;   //  Veremos cuanto tiene la que sigue
    }

    private boolean esSeparador(char car) {
        boolean signo = false; int ind; char sepa;
        for(ind = 0; ind < separa.length(); ind++) {
            sepa = (char)separa.charAt(ind);
            if (car == sepa) {      // encontro, es signo o espacio
                signo = true; break;
            }
        }
        return signo;
    }

    private void finPalabra(int ind){
        if(contLetras >= masLarga){ //  La nueva palabra palabra > anterior
            masLarga = contLetras;
            palLarga = palabra;
            posFin = ind;   //  Posicion del separador post a ultima letra
            larIni = posIni;
            larFin = posFin;
        }
        System.out.println("palabra: " + palabra);
        palabra = "";
        contLetras = 0;
        primeraLetra = true;
    }

    public String toString(){
        String aux = "";
        aux += "Linea leida:      " + lineaLeid + "\n";
        aux += "Hemos borrado:    " + borradas  + " palabras\n";
        aux += "Linea deleteada:  " + lineaTrab + "\n";
        aux += "Linea resultante: " + lineaRes  + "\n";
        return aux;
    }
}
